import { map, materialize, tap } from 'rxjs/operators';
export function rxMaterialize() {
    return o$ => o$.pipe(materialize(), tap(({ kind, error }) => {
        if (kind === 'E') {
            console.error(error);
        }
    }), map(({ value, hasValue, error, kind }) => ({
        value,
        hasValue,
        error,
        kind: notificationKindToRxNotificationKind(kind)
    })));
}
export function notificationKindToRxNotificationKind(kind) {
    switch (kind) {
        case 'C':
            return 'rxComplete';
        case 'E':
            return 'rxError';
        case 'N':
        default:
            return 'rxNext';
    }
}
//# sourceMappingURL=rx-materialize.js.map