import { __awaiter } from "tslib";
import { chain, } from '@angular-devkit/schematics';
import { addPackageJsonDependency, } from '@schematics/angular/utility/dependencies';
import { findRootModule, getLatestNodePackage, getProject, peerDependencies, } from '../../common';
import { combineLatest } from 'rxjs';
import { map } from 'rxjs/operators';
// function getModuleFile(tree: Tree, options: SchemaOptions): ts.SourceFile {
//   const modulePath = options.module;
//
//   if (!tree.exists(modulePath)) {
//     throw new SchematicsException(`File ${modulePath} does not exist.`);
//   }
//
//   const text = tree.read(modulePath);
//   if (text === null) {
//     throw new SchematicsException(`File ${modulePath} does not exist.`);
//   }
//   const sourceText = text.toString('utf-8');
//
//   return ts.createSourceFile(
//     modulePath,
//     sourceText,
//     ts.ScriptTarget.Latest,
//     true
//   );
// }
// function applyChanges(tree: Tree, path: string, changes: InsertChange[]): Tree {
//   const recorder = tree.beginUpdate(path);
//
//   for (const change of changes) {
//     recorder.insertLeft(change.pos, change.toAdd);
//   }
//
//   tree.commitUpdate(recorder);
//
//   return tree;
// }
// function addImportsToModuleFile(
//   options: SchemaOptions,
//   imports: string[],
//   importName = packageName
// ): Rule {
//   return (tree) => {
//     const module = getModuleFile(tree, options);
//     const importChanges = insertImport(
//       module,
//       options.module,
//       imports.join(', '),
//       importName
//     );
//
//     return applyChanges(tree, options.module, [
//       importChanges,
//     ] as InsertChange[]);
//   };
// }
// function addImportsToModuleDeclaration(
//   options: SchemaOptions,
//   imports: string[]
// ): Rule {
//   return (tree) => {
//     const module = getModuleFile(tree, options);
//
//     const importChanges = imports.map(
//       (imp) => addImportToModule(module, options.module, imp, packageName)[0]
//     );
//
//     return applyChanges(tree, options.module, importChanges as InsertChange[]);
//   };
// }
function addPackageJsonDependencies(packages) {
    return (tree, context) => {
        const packageNames = packages.map((p) => typeof p === 'string' ? p : p.name);
        return combineLatest(packageNames.map((name) => getLatestNodePackage(name))).pipe(map((nodeDependencies) => {
            nodeDependencies.forEach((nodeDependency) => {
                addPackageJsonDependency(tree, nodeDependency);
                context.logger.info(`✅️Added dependency ${nodeDependency.name}@${nodeDependency.version}`);
            });
            return tree;
        }));
    };
}
export function ngAdd(options) {
    return (tree) => __awaiter(this, void 0, void 0, function* () {
        var _a;
        const project = yield getProject(tree, options.project);
        const sourceRoot = (_a = (project && project.sourceRoot)) !== null && _a !== void 0 ? _a : 'src';
        options.module = findRootModule(tree, options.module, sourceRoot);
        return chain([
            addPackageJsonDependencies(peerDependencies),
        ]);
    });
}
//# sourceMappingURL=index.js.map