import { NodeDependencyType, } from '@schematics/angular/utility/dependencies';
import { fromPromise } from 'rxjs/internal-compatibility';
import { map, take } from 'rxjs/operators';
import fetch from 'node-fetch';
export function getLatestNodePackage(name) {
    return fromPromise(fetch(`https://registry.npmjs.org/${name}/latest`).then((res) => res.json())).pipe(map((packageData) => ({
        type: NodeDependencyType.Default,
        name: packageData.name,
        version: packageData.version,
        overwrite: false,
    })), take(1));
}
//# sourceMappingURL=npmjs.js.map