"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngAdd = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const dependencies_1 = require("@schematics/angular/utility/dependencies");
const common_1 = require("../../common");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
// function getModuleFile(tree: Tree, options: SchemaOptions): ts.SourceFile {
//   const modulePath = options.module;
//
//   if (!tree.exists(modulePath)) {
//     throw new SchematicsException(`File ${modulePath} does not exist.`);
//   }
//
//   const text = tree.read(modulePath);
//   if (text === null) {
//     throw new SchematicsException(`File ${modulePath} does not exist.`);
//   }
//   const sourceText = text.toString('utf-8');
//
//   return ts.createSourceFile(
//     modulePath,
//     sourceText,
//     ts.ScriptTarget.Latest,
//     true
//   );
// }
// function applyChanges(tree: Tree, path: string, changes: InsertChange[]): Tree {
//   const recorder = tree.beginUpdate(path);
//
//   for (const change of changes) {
//     recorder.insertLeft(change.pos, change.toAdd);
//   }
//
//   tree.commitUpdate(recorder);
//
//   return tree;
// }
// function addImportsToModuleFile(
//   options: SchemaOptions,
//   imports: string[],
//   importName = packageName
// ): Rule {
//   return (tree) => {
//     const module = getModuleFile(tree, options);
//     const importChanges = insertImport(
//       module,
//       options.module,
//       imports.join(', '),
//       importName
//     );
//
//     return applyChanges(tree, options.module, [
//       importChanges,
//     ] as InsertChange[]);
//   };
// }
// function addImportsToModuleDeclaration(
//   options: SchemaOptions,
//   imports: string[]
// ): Rule {
//   return (tree) => {
//     const module = getModuleFile(tree, options);
//
//     const importChanges = imports.map(
//       (imp) => addImportToModule(module, options.module, imp, packageName)[0]
//     );
//
//     return applyChanges(tree, options.module, importChanges as InsertChange[]);
//   };
// }
function addPackageJsonDependencies(packages) {
    return (tree, context) => {
        const packageNames = packages.map((p) => typeof p === 'string' ? p : p.name);
        return rxjs_1.combineLatest(packageNames.map((name) => common_1.getLatestNodePackage(name))).pipe(operators_1.map((nodeDependencies) => {
            nodeDependencies.forEach((nodeDependency) => {
                dependencies_1.addPackageJsonDependency(tree, nodeDependency);
                context.logger.info(`✅️Added dependency ${nodeDependency.name}@${nodeDependency.version}`);
            });
            return tree;
        }));
    };
}
function ngAdd(options) {
    return (tree) => __awaiter(this, void 0, void 0, function* () {
        var _a;
        const project = yield common_1.getProject(tree, options.project);
        const sourceRoot = (_a = (project && project.sourceRoot)) !== null && _a !== void 0 ? _a : 'src';
        options.module = common_1.findRootModule(tree, options.module, sourceRoot);
        return schematics_1.chain([
            addPackageJsonDependencies(common_1.peerDependencies),
        ]);
    });
}
exports.ngAdd = ngAdd;
