"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLatestNodePackage = void 0;
const dependencies_1 = require("@schematics/angular/utility/dependencies");
const internal_compatibility_1 = require("rxjs/internal-compatibility");
const operators_1 = require("rxjs/operators");
const node_fetch_1 = require("node-fetch");
function getLatestNodePackage(name) {
    return internal_compatibility_1.fromPromise(node_fetch_1.default(`https://registry.npmjs.org/${name}/latest`).then((res) => res.json())).pipe(operators_1.map((packageData) => ({
        type: dependencies_1.NodeDependencyType.Default,
        name: packageData.name,
        version: packageData.version,
        overwrite: false,
    })), operators_1.take(1));
}
exports.getLatestNodePackage = getLatestNodePackage;
